=begin
#imageapi

#Image Recognition and Processing APIs let you use Machine Learning to recognize and process images, and also perform useful image modification operations.

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.14

=end

require 'uri'

module CloudmersiveImageRecognitionApiClient
  class TextGenerationApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create an image of handwriting in PNG format
    # Uses Deep Learning to generate realistic handwriting and returns the result as a PNG image
    # @param request Draw text parameters
    # @param [Hash] opts the optional parameters
    # @return [Object]
    def text_generation_create_handwriting_png(request, opts = {})
      data, _status_code, _headers = text_generation_create_handwriting_png_with_http_info(request, opts)
      data
    end

    # Create an image of handwriting in PNG format
    # Uses Deep Learning to generate realistic handwriting and returns the result as a PNG image
    # @param request Draw text parameters
    # @param [Hash] opts the optional parameters
    # @return [Array<(Object, Fixnum, Hash)>] Object data, response status code and response headers
    def text_generation_create_handwriting_png_with_http_info(request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TextGenerationApi.text_generation_create_handwriting_png ...'
      end
      # verify the required parameter 'request' is set
      if @api_client.config.client_side_validation && request.nil?
        fail ArgumentError, "Missing the required parameter 'request' when calling TextGenerationApi.text_generation_create_handwriting_png"
      end
      # resource path
      local_var_path = '/image/text/create/handwriting/png'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/octet-stream'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(request)
      auth_names = ['Apikey']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Object')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TextGenerationApi#text_generation_create_handwriting_png\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
